/* ShadowEffect.c generated by valac 0.56.17, the Vala compiler
 * generated from ShadowEffect.vala, do not modify */

/*
 * Copyright 2014 Tom Beckmann
 * Copyright 2023 elementary, Inc. <https://elementary.io>
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include "gala.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <cogl/cogl.h>
#include <clutter/clutter.h>
#include <gee.h>
#include <glib-object.h>
#include <cairo-gobject.h>
#include <graphene-gobject.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GALA_SHADOW_EFFECT_0_PROPERTY,
	GALA_SHADOW_EFFECT_CSS_CLASS_PROPERTY,
	GALA_SHADOW_EFFECT_SCALE_FACTOR_PROPERTY,
	GALA_SHADOW_EFFECT_SHADOW_OPACITY_PROPERTY,
	GALA_SHADOW_EFFECT_BORDER_RADIUS_PROPERTY,
	GALA_SHADOW_EFFECT_NUM_PROPERTIES
};
static GParamSpec* gala_shadow_effect_properties[GALA_SHADOW_EFFECT_NUM_PROPERTIES];

#define GALA_SHADOW_EFFECT_TYPE_SHADOW (gala_shadow_effect_shadow_get_type ())
#define GALA_SHADOW_EFFECT_SHADOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_SHADOW_EFFECT_TYPE_SHADOW, GalaShadowEffectShadow))
#define GALA_SHADOW_EFFECT_SHADOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_SHADOW_EFFECT_TYPE_SHADOW, GalaShadowEffectShadowClass))
#define GALA_SHADOW_EFFECT_IS_SHADOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_SHADOW_EFFECT_TYPE_SHADOW))
#define GALA_SHADOW_EFFECT_IS_SHADOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_SHADOW_EFFECT_TYPE_SHADOW))
#define GALA_SHADOW_EFFECT_SHADOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_SHADOW_EFFECT_TYPE_SHADOW, GalaShadowEffectShadowClass))

typedef struct _GalaShadowEffectShadow GalaShadowEffectShadow;
typedef struct _GalaShadowEffectShadowClass GalaShadowEffectShadowClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _GalaShadowEffectShadowPrivate GalaShadowEffectShadowPrivate;
#define _gala_shadow_effect_shadow_unref0(var) ((var == NULL) ? NULL : (var = (gala_shadow_effect_shadow_unref (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block4Data Block4Data;
typedef struct _GalaShadowEffectParamSpecShadow GalaShadowEffectParamSpecShadow;

struct _GalaShadowEffectPrivate {
	gchar* _css_class;
	gfloat _scale_factor;
	guint8 _shadow_opacity;
	gint _border_radius;
	gint shadow_size;
	CoglPipeline* pipeline;
	gchar* current_key;
};

struct _GalaShadowEffectShadow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GalaShadowEffectShadowPrivate * priv;
	gint users;
	CoglTexture* texture;
};

struct _GalaShadowEffectShadowClass {
	GTypeClass parent_class;
	void (*finalize) (GalaShadowEffectShadow *self);
};

struct _Block4Data {
	int _ref_count_;
	gchar* key;
};

struct _GalaShadowEffectParamSpecShadow {
	GParamSpec parent_instance;
};

static gint GalaShadowEffect_private_offset;
static gpointer gala_shadow_effect_parent_class = NULL;
static GeeHashMap* gala_shadow_effect_shadow_cache;
static GeeHashMap* gala_shadow_effect_shadow_cache = NULL;
static GeeHashMap* gala_shadow_effect_shadows_marked_for_dropping;
static GeeHashMap* gala_shadow_effect_shadows_marked_for_dropping = NULL;
static gpointer gala_shadow_effect_shadow_parent_class = NULL;

static void gala_shadow_effect_decrement_shadow_users (const gchar* key);
static gpointer gala_shadow_effect_shadow_ref (gpointer instance);
static void gala_shadow_effect_shadow_unref (gpointer instance);
static GParamSpec* gala_shadow_effect_param_spec_shadow (const gchar* name,
                                                  const gchar* nick,
                                                  const gchar* blurb,
                                                  GType object_type,
                                                  GParamFlags flags) G_GNUC_UNUSED ;
static void gala_shadow_effect_value_set_shadow (GValue* value,
                                          gpointer v_object) G_GNUC_UNUSED ;
static void gala_shadow_effect_value_take_shadow (GValue* value,
                                           gpointer v_object) G_GNUC_UNUSED ;
static gpointer gala_shadow_effect_value_get_shadow (const GValue* value) G_GNUC_UNUSED ;
static GType gala_shadow_effect_shadow_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static CoglTexture* gala_shadow_effect_get_shadow (GalaShadowEffect* self,
                                            CoglContext* context,
                                            gint width,
                                            gint height,
                                            gint shadow_size);
static void gala_shadow_effect_increment_shadow_users (const gchar* key);
static GalaShadowEffectShadow* gala_shadow_effect_shadow_new (CoglTexture* _texture);
static GalaShadowEffectShadow* gala_shadow_effect_shadow_construct (GType object_type,
                                                             CoglTexture* _texture);
static void gala_shadow_effect_real_paint (ClutterEffect* base,
                                    ClutterPaintNode* node,
                                    ClutterPaintContext* context,
                                    ClutterEffectPaintFlags flags);
static void gala_shadow_effect_get_bounding_box (GalaShadowEffect* self,
                                          ClutterActorBox* result);
static gboolean gala_shadow_effect_real_modify_paint_volume (ClutterEffect* base,
                                                      ClutterPaintVolume* volume);
static void gala_shadow_effect_queue_shadow_drop (const gchar* key);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static gboolean __lambda21_ (Block4Data* _data4_);
static gboolean ___lambda21__gsource_func (gpointer self);
static void gala_shadow_effect_shadow_finalize (GalaShadowEffectShadow * obj);
static GType gala_shadow_effect_shadow_get_type_once (void);
static GObject * gala_shadow_effect_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void gala_shadow_effect_finalize (GObject * obj);
static GType gala_shadow_effect_get_type_once (void);
static void _vala_gala_shadow_effect_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_gala_shadow_effect_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);

static inline gpointer
gala_shadow_effect_get_instance_private (GalaShadowEffect* self)
{
	return G_STRUCT_MEMBER_P (self, GalaShadowEffect_private_offset);
}

GalaShadowEffect*
gala_shadow_effect_construct (GType object_type,
                              const gchar* css_class)
{
	GalaShadowEffect * self = NULL;
#line 61 "../lib/ShadowEffect.vala"
	g_return_val_if_fail (css_class != NULL, NULL);
#line 62 "../lib/ShadowEffect.vala"
	self = (GalaShadowEffect*) g_object_new (object_type, "css-class", css_class, NULL);
#line 61 "../lib/ShadowEffect.vala"
	return self;
#line 172 "ShadowEffect.c"
}

GalaShadowEffect*
gala_shadow_effect_new (const gchar* css_class)
{
#line 61 "../lib/ShadowEffect.vala"
	return gala_shadow_effect_construct (GALA_TYPE_SHADOW_EFFECT, css_class);
#line 180 "ShadowEffect.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 89 "../lib/ShadowEffect.vala"
	return self ? g_object_ref (self) : NULL;
#line 188 "ShadowEffect.c"
}

static CoglTexture*
gala_shadow_effect_get_shadow (GalaShadowEffect* self,
                               CoglContext* context,
                               gint width,
                               gint height,
                               gint shadow_size)
{
	gchar* old_key = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GalaShadowEffectShadow* shadow = NULL;
	GeeHashMap* _tmp7_;
	const gchar* _tmp8_;
	gpointer _tmp9_;
	GalaShadowEffectShadow* _tmp10_;
	GalaDrawingBufferSurface* buffer = NULL;
	GalaDrawingBufferSurface* _tmp15_;
	GalaDrawingBufferSurface* _tmp16_;
	cairo_t* _tmp17_;
	cairo_t* _tmp18_;
	gint _tmp19_;
	GalaDrawingBufferSurface* _tmp20_;
	cairo_t* _tmp21_;
	cairo_t* _tmp22_;
	GalaDrawingBufferSurface* _tmp23_;
	cairo_t* _tmp24_;
	cairo_t* _tmp25_;
	GalaDrawingBufferSurface* _tmp26_;
	cairo_surface_t* surface = NULL;
	cairo_surface_t* _tmp27_;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp28_;
	cairo_t* _tmp29_;
	cairo_t* _tmp30_;
	GalaDrawingBufferSurface* _tmp31_;
	cairo_surface_t* _tmp32_;
	cairo_surface_t* _tmp33_;
	cairo_t* _tmp34_;
	cairo_t* _tmp35_;
	cairo_t* _tmp36_;
	gfloat size = 0.0F;
	gfloat _tmp37_;
	cairo_t* _tmp38_;
	ClutterActor* _tmp39_;
	ClutterActor* _tmp40_;
	gfloat _tmp41_;
	gfloat _tmp42_;
	ClutterActor* _tmp43_;
	ClutterActor* _tmp44_;
	gfloat _tmp45_;
	gfloat _tmp46_;
	gint _tmp47_;
	cairo_t* _tmp48_;
	cairo_t* _tmp49_;
	GError* _inner_error0_ = NULL;
	CoglTexture* result;
#line 75 "../lib/ShadowEffect.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 75 "../lib/ShadowEffect.vala"
	g_return_val_if_fail (context != NULL, NULL);
#line 76 "../lib/ShadowEffect.vala"
	_tmp0_ = self->priv->current_key;
#line 76 "../lib/ShadowEffect.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 76 "../lib/ShadowEffect.vala"
	old_key = _tmp1_;
#line 77 "../lib/ShadowEffect.vala"
	_tmp2_ = g_strdup_printf ("%ix%i:%i", width, height, shadow_size);
#line 77 "../lib/ShadowEffect.vala"
	_g_free0 (self->priv->current_key);
#line 77 "../lib/ShadowEffect.vala"
	self->priv->current_key = _tmp2_;
#line 78 "../lib/ShadowEffect.vala"
	_tmp3_ = old_key;
#line 78 "../lib/ShadowEffect.vala"
	_tmp4_ = self->priv->current_key;
#line 78 "../lib/ShadowEffect.vala"
	if (g_strcmp0 (_tmp3_, _tmp4_) == 0) {
#line 79 "../lib/ShadowEffect.vala"
		result = NULL;
#line 79 "../lib/ShadowEffect.vala"
		_g_free0 (old_key);
#line 79 "../lib/ShadowEffect.vala"
		return result;
#line 279 "ShadowEffect.c"
	}
#line 82 "../lib/ShadowEffect.vala"
	_tmp5_ = old_key;
#line 82 "../lib/ShadowEffect.vala"
	if (_tmp5_ != NULL) {
#line 285 "ShadowEffect.c"
		const gchar* _tmp6_;
#line 83 "../lib/ShadowEffect.vala"
		_tmp6_ = old_key;
#line 83 "../lib/ShadowEffect.vala"
		gala_shadow_effect_decrement_shadow_users (_tmp6_);
#line 291 "ShadowEffect.c"
	}
#line 86 "../lib/ShadowEffect.vala"
	_tmp7_ = gala_shadow_effect_shadow_cache;
#line 86 "../lib/ShadowEffect.vala"
	_tmp8_ = self->priv->current_key;
#line 86 "../lib/ShadowEffect.vala"
	_tmp9_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp7_, _tmp8_);
#line 86 "../lib/ShadowEffect.vala"
	shadow = (GalaShadowEffectShadow*) _tmp9_;
#line 87 "../lib/ShadowEffect.vala"
	_tmp10_ = shadow;
#line 87 "../lib/ShadowEffect.vala"
	if (_tmp10_ != NULL) {
#line 305 "ShadowEffect.c"
		const gchar* _tmp11_;
		GalaShadowEffectShadow* _tmp12_;
		CoglTexture* _tmp13_;
		CoglTexture* _tmp14_;
#line 88 "../lib/ShadowEffect.vala"
		_tmp11_ = self->priv->current_key;
#line 88 "../lib/ShadowEffect.vala"
		gala_shadow_effect_increment_shadow_users (_tmp11_);
#line 89 "../lib/ShadowEffect.vala"
		_tmp12_ = shadow;
#line 89 "../lib/ShadowEffect.vala"
		_tmp13_ = _tmp12_->texture;
#line 89 "../lib/ShadowEffect.vala"
		_tmp14_ = _g_object_ref0 (_tmp13_);
#line 89 "../lib/ShadowEffect.vala"
		result = _tmp14_;
#line 89 "../lib/ShadowEffect.vala"
		_gala_shadow_effect_shadow_unref0 (shadow);
#line 89 "../lib/ShadowEffect.vala"
		_g_free0 (old_key);
#line 89 "../lib/ShadowEffect.vala"
		return result;
#line 328 "ShadowEffect.c"
	}
#line 93 "../lib/ShadowEffect.vala"
	_tmp15_ = gala_drawing_buffer_surface_new (width, height);
#line 93 "../lib/ShadowEffect.vala"
	buffer = _tmp15_;
#line 94 "../lib/ShadowEffect.vala"
	_tmp16_ = buffer;
#line 94 "../lib/ShadowEffect.vala"
	_tmp17_ = gala_drawing_buffer_surface_get_context (_tmp16_);
#line 94 "../lib/ShadowEffect.vala"
	_tmp18_ = _tmp17_;
#line 94 "../lib/ShadowEffect.vala"
	_tmp19_ = self->priv->_border_radius;
#line 94 "../lib/ShadowEffect.vala"
	gala_drawing_utilities_cairo_rounded_rectangle (_tmp18_, (gdouble) shadow_size, (gdouble) shadow_size, (gdouble) (width - (shadow_size * 2)), (gdouble) (height - (shadow_size * 2)), (gdouble) _tmp19_);
#line 103 "../lib/ShadowEffect.vala"
	_tmp20_ = buffer;
#line 103 "../lib/ShadowEffect.vala"
	_tmp21_ = gala_drawing_buffer_surface_get_context (_tmp20_);
#line 103 "../lib/ShadowEffect.vala"
	_tmp22_ = _tmp21_;
#line 103 "../lib/ShadowEffect.vala"
	cairo_set_source_rgba (_tmp22_, (gdouble) 0, (gdouble) 0, (gdouble) 0, 0.7);
#line 104 "../lib/ShadowEffect.vala"
	_tmp23_ = buffer;
#line 104 "../lib/ShadowEffect.vala"
	_tmp24_ = gala_drawing_buffer_surface_get_context (_tmp23_);
#line 104 "../lib/ShadowEffect.vala"
	_tmp25_ = _tmp24_;
#line 104 "../lib/ShadowEffect.vala"
	cairo_fill (_tmp25_);
#line 106 "../lib/ShadowEffect.vala"
	_tmp26_ = buffer;
#line 106 "../lib/ShadowEffect.vala"
	gala_drawing_buffer_surface_exponential_blur (_tmp26_, shadow_size / 2);
#line 108 "../lib/ShadowEffect.vala"
	_tmp27_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, width, height);
#line 108 "../lib/ShadowEffect.vala"
	surface = _tmp27_;
#line 109 "../lib/ShadowEffect.vala"
	_tmp28_ = surface;
#line 109 "../lib/ShadowEffect.vala"
	_tmp29_ = cairo_create (_tmp28_);
#line 109 "../lib/ShadowEffect.vala"
	cr = _tmp29_;
#line 110 "../lib/ShadowEffect.vala"
	_tmp30_ = cr;
#line 110 "../lib/ShadowEffect.vala"
	_tmp31_ = buffer;
#line 110 "../lib/ShadowEffect.vala"
	_tmp32_ = gala_drawing_buffer_surface_get_surface (_tmp31_);
#line 110 "../lib/ShadowEffect.vala"
	_tmp33_ = _tmp32_;
#line 110 "../lib/ShadowEffect.vala"
	cairo_set_source_surface (_tmp30_, _tmp33_, (gdouble) 0, (gdouble) 0);
#line 111 "../lib/ShadowEffect.vala"
	_tmp34_ = cr;
#line 111 "../lib/ShadowEffect.vala"
	cairo_paint (_tmp34_);
#line 113 "../lib/ShadowEffect.vala"
	_tmp35_ = cr;
#line 113 "../lib/ShadowEffect.vala"
	cairo_save (_tmp35_);
#line 114 "../lib/ShadowEffect.vala"
	_tmp36_ = cr;
#line 114 "../lib/ShadowEffect.vala"
	cairo_set_operator (_tmp36_, CAIRO_OPERATOR_CLEAR);
#line 115 "../lib/ShadowEffect.vala"
	_tmp37_ = self->priv->_scale_factor;
#line 115 "../lib/ShadowEffect.vala"
	size = shadow_size * _tmp37_;
#line 116 "../lib/ShadowEffect.vala"
	_tmp38_ = cr;
#line 116 "../lib/ShadowEffect.vala"
	_tmp39_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 116 "../lib/ShadowEffect.vala"
	_tmp40_ = _tmp39_;
#line 116 "../lib/ShadowEffect.vala"
	_tmp41_ = clutter_actor_get_width (_tmp40_);
#line 116 "../lib/ShadowEffect.vala"
	_tmp42_ = _tmp41_;
#line 116 "../lib/ShadowEffect.vala"
	_tmp43_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 116 "../lib/ShadowEffect.vala"
	_tmp44_ = _tmp43_;
#line 116 "../lib/ShadowEffect.vala"
	_tmp45_ = clutter_actor_get_height (_tmp44_);
#line 116 "../lib/ShadowEffect.vala"
	_tmp46_ = _tmp45_;
#line 116 "../lib/ShadowEffect.vala"
	_tmp47_ = self->priv->_border_radius;
#line 116 "../lib/ShadowEffect.vala"
	gala_drawing_utilities_cairo_rounded_rectangle (_tmp38_, (gdouble) size, (gdouble) size, (gdouble) _tmp42_, (gdouble) _tmp46_, (gdouble) _tmp47_);
#line 117 "../lib/ShadowEffect.vala"
	_tmp48_ = cr;
#line 117 "../lib/ShadowEffect.vala"
	cairo_fill (_tmp48_);
#line 118 "../lib/ShadowEffect.vala"
	_tmp49_ = cr;
#line 118 "../lib/ShadowEffect.vala"
	cairo_restore (_tmp49_);
#line 430 "ShadowEffect.c"
	{
		CoglTexture2D* texture = NULL;
		cairo_surface_t* _tmp50_;
		cairo_surface_t* _tmp51_;
		guchar* _tmp52_;
		CoglTexture2D* _tmp53_;
		GeeHashMap* _tmp54_;
		const gchar* _tmp55_;
		CoglTexture2D* _tmp56_;
		GalaShadowEffectShadow* _tmp57_;
		GalaShadowEffectShadow* _tmp58_;
#line 121 "../lib/ShadowEffect.vala"
		_tmp50_ = surface;
#line 121 "../lib/ShadowEffect.vala"
		_tmp51_ = surface;
#line 121 "../lib/ShadowEffect.vala"
		_tmp52_ = cairo_image_surface_get_data (_tmp51_);
#line 121 "../lib/ShadowEffect.vala"
		_tmp53_ = (CoglTexture2D*) cogl_texture_2d_new_from_data (context, width, height, COGL_PIXEL_FORMAT_BGRA_8888_PRE, cairo_image_surface_get_stride (_tmp50_), _tmp52_, &_inner_error0_);
#line 121 "../lib/ShadowEffect.vala"
		texture = _tmp53_;
#line 121 "../lib/ShadowEffect.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 454 "ShadowEffect.c"
			goto __catch0_g_error;
		}
#line 123 "../lib/ShadowEffect.vala"
		_tmp54_ = gala_shadow_effect_shadow_cache;
#line 123 "../lib/ShadowEffect.vala"
		_tmp55_ = self->priv->current_key;
#line 123 "../lib/ShadowEffect.vala"
		_tmp56_ = texture;
#line 123 "../lib/ShadowEffect.vala"
		_tmp57_ = gala_shadow_effect_shadow_new ((CoglTexture*) _tmp56_);
#line 123 "../lib/ShadowEffect.vala"
		_tmp58_ = _tmp57_;
#line 123 "../lib/ShadowEffect.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp54_, _tmp55_, _tmp58_);
#line 123 "../lib/ShadowEffect.vala"
		_gala_shadow_effect_shadow_unref0 (_tmp58_);
#line 125 "../lib/ShadowEffect.vala"
		result = (CoglTexture*) texture;
#line 125 "../lib/ShadowEffect.vala"
		_cairo_destroy0 (cr);
#line 125 "../lib/ShadowEffect.vala"
		_cairo_surface_destroy0 (surface);
#line 125 "../lib/ShadowEffect.vala"
		_g_object_unref0 (buffer);
#line 125 "../lib/ShadowEffect.vala"
		_gala_shadow_effect_shadow_unref0 (shadow);
#line 125 "../lib/ShadowEffect.vala"
		_g_free0 (old_key);
#line 125 "../lib/ShadowEffect.vala"
		return result;
#line 485 "ShadowEffect.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp59_;
		const gchar* _tmp60_;
#line 120 "../lib/ShadowEffect.vala"
		e = _inner_error0_;
#line 120 "../lib/ShadowEffect.vala"
		_inner_error0_ = NULL;
#line 127 "../lib/ShadowEffect.vala"
		_tmp59_ = e;
#line 127 "../lib/ShadowEffect.vala"
		_tmp60_ = _tmp59_->message;
#line 127 "../lib/ShadowEffect.vala"
		g_debug ("ShadowEffect.vala:127: %s", _tmp60_);
#line 128 "../lib/ShadowEffect.vala"
		result = NULL;
#line 128 "../lib/ShadowEffect.vala"
		_g_error_free0 (e);
#line 128 "../lib/ShadowEffect.vala"
		_cairo_destroy0 (cr);
#line 128 "../lib/ShadowEffect.vala"
		_cairo_surface_destroy0 (surface);
#line 128 "../lib/ShadowEffect.vala"
		_g_object_unref0 (buffer);
#line 128 "../lib/ShadowEffect.vala"
		_gala_shadow_effect_shadow_unref0 (shadow);
#line 128 "../lib/ShadowEffect.vala"
		_g_free0 (old_key);
#line 128 "../lib/ShadowEffect.vala"
		return result;
#line 519 "ShadowEffect.c"
	}
	__finally0:
#line 120 "../lib/ShadowEffect.vala"
	_cairo_destroy0 (cr);
#line 120 "../lib/ShadowEffect.vala"
	_cairo_surface_destroy0 (surface);
#line 120 "../lib/ShadowEffect.vala"
	_g_object_unref0 (buffer);
#line 120 "../lib/ShadowEffect.vala"
	_gala_shadow_effect_shadow_unref0 (shadow);
#line 120 "../lib/ShadowEffect.vala"
	_g_free0 (old_key);
#line 120 "../lib/ShadowEffect.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 120 "../lib/ShadowEffect.vala"
	g_clear_error (&_inner_error0_);
#line 120 "../lib/ShadowEffect.vala"
	return NULL;
#line 538 "ShadowEffect.c"
}

static void
gala_shadow_effect_real_paint (ClutterEffect* base,
                               ClutterPaintNode* node,
                               ClutterPaintContext* context,
                               ClutterEffectPaintFlags flags)
{
	GalaShadowEffect * self;
	ClutterActorBox bounding_box = {0};
	ClutterActorBox _tmp0_ = {0};
	gint width = 0;
	ClutterActorBox _tmp1_;
	ClutterActorBox _tmp2_;
	gint height = 0;
	ClutterActorBox _tmp3_;
	ClutterActorBox _tmp4_;
	CoglTexture* shadow = NULL;
	CoglFramebuffer* _tmp5_;
	CoglContext* _tmp6_;
	CoglTexture* _tmp7_;
	CoglTexture* _tmp8_;
	gfloat opacity = 0.0F;
	ClutterActor* _tmp11_;
	ClutterActor* _tmp12_;
	guint8 _tmp13_;
	CoglColor alpha = {0};
	CoglPipeline* _tmp14_;
	CoglColor _tmp15_;
	CoglFramebuffer* _tmp16_;
	CoglPipeline* _tmp17_;
	ClutterActorBox _tmp18_;
	ClutterActorBox _tmp19_;
	ClutterActorBox _tmp20_;
	ClutterActorBox _tmp21_;
	ClutterActor* _tmp22_;
	ClutterActor* _tmp23_;
#line 132 "../lib/ShadowEffect.vala"
	self = (GalaShadowEffect*) base;
#line 132 "../lib/ShadowEffect.vala"
	g_return_if_fail (node != NULL);
#line 132 "../lib/ShadowEffect.vala"
	g_return_if_fail (context != NULL);
#line 133 "../lib/ShadowEffect.vala"
	gala_shadow_effect_get_bounding_box (self, &_tmp0_);
#line 133 "../lib/ShadowEffect.vala"
	bounding_box = _tmp0_;
#line 134 "../lib/ShadowEffect.vala"
	_tmp1_ = bounding_box;
#line 134 "../lib/ShadowEffect.vala"
	_tmp2_ = bounding_box;
#line 134 "../lib/ShadowEffect.vala"
	width = (gint) (_tmp1_.x2 - _tmp2_.x1);
#line 135 "../lib/ShadowEffect.vala"
	_tmp3_ = bounding_box;
#line 135 "../lib/ShadowEffect.vala"
	_tmp4_ = bounding_box;
#line 135 "../lib/ShadowEffect.vala"
	height = (gint) (_tmp3_.y2 - _tmp4_.y1);
#line 137 "../lib/ShadowEffect.vala"
	_tmp5_ = clutter_paint_context_get_framebuffer (context);
#line 137 "../lib/ShadowEffect.vala"
	_tmp6_ = cogl_framebuffer_get_context (_tmp5_);
#line 137 "../lib/ShadowEffect.vala"
	_tmp7_ = gala_shadow_effect_get_shadow (self, _tmp6_, width, height, self->priv->shadow_size);
#line 137 "../lib/ShadowEffect.vala"
	shadow = _tmp7_;
#line 138 "../lib/ShadowEffect.vala"
	_tmp8_ = shadow;
#line 138 "../lib/ShadowEffect.vala"
	if (_tmp8_ != NULL) {
#line 610 "ShadowEffect.c"
		CoglPipeline* _tmp9_;
		CoglTexture* _tmp10_;
#line 139 "../lib/ShadowEffect.vala"
		_tmp9_ = self->priv->pipeline;
#line 139 "../lib/ShadowEffect.vala"
		_tmp10_ = shadow;
#line 139 "../lib/ShadowEffect.vala"
		cogl_pipeline_set_layer_texture (_tmp9_, 0, _tmp10_);
#line 619 "ShadowEffect.c"
	}
#line 142 "../lib/ShadowEffect.vala"
	_tmp11_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 142 "../lib/ShadowEffect.vala"
	_tmp12_ = _tmp11_;
#line 142 "../lib/ShadowEffect.vala"
	_tmp13_ = self->priv->_shadow_opacity;
#line 142 "../lib/ShadowEffect.vala"
	opacity = (clutter_actor_get_paint_opacity (_tmp12_) * _tmp13_) / 255.0f;
#line 143 "../lib/ShadowEffect.vala"
	cogl_color_init_from_4f (&alpha, 1.0f, 1.0f, 1.0f, opacity / 255.0f);
#line 144 "../lib/ShadowEffect.vala"
	cogl_color_premultiply (&alpha);
#line 146 "../lib/ShadowEffect.vala"
	_tmp14_ = self->priv->pipeline;
#line 146 "../lib/ShadowEffect.vala"
	_tmp15_ = alpha;
#line 146 "../lib/ShadowEffect.vala"
	cogl_pipeline_set_color (_tmp14_, &_tmp15_);
#line 148 "../lib/ShadowEffect.vala"
	_tmp16_ = clutter_paint_context_get_framebuffer (context);
#line 148 "../lib/ShadowEffect.vala"
	_tmp17_ = self->priv->pipeline;
#line 148 "../lib/ShadowEffect.vala"
	_tmp18_ = bounding_box;
#line 148 "../lib/ShadowEffect.vala"
	_tmp19_ = bounding_box;
#line 148 "../lib/ShadowEffect.vala"
	_tmp20_ = bounding_box;
#line 148 "../lib/ShadowEffect.vala"
	_tmp21_ = bounding_box;
#line 148 "../lib/ShadowEffect.vala"
	cogl_framebuffer_draw_rectangle (_tmp16_, _tmp17_, _tmp18_.x1, _tmp19_.y1, _tmp20_.x2, _tmp21_.y2);
#line 150 "../lib/ShadowEffect.vala"
	_tmp22_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 150 "../lib/ShadowEffect.vala"
	_tmp23_ = _tmp22_;
#line 150 "../lib/ShadowEffect.vala"
	clutter_actor_continue_paint (_tmp23_, context);
#line 132 "../lib/ShadowEffect.vala"
	_g_object_unref0 (shadow);
#line 661 "ShadowEffect.c"
}

static void
gala_shadow_effect_get_bounding_box (GalaShadowEffect* self,
                                     ClutterActorBox* result)
{
	gfloat size = 0.0F;
	gfloat _tmp0_;
	ClutterActorBox bounding_box = {0};
	ClutterActor* _tmp1_;
	ClutterActor* _tmp2_;
	gfloat _tmp3_;
	gfloat _tmp4_;
	ClutterActor* _tmp5_;
	ClutterActor* _tmp6_;
	gfloat _tmp7_;
	gfloat _tmp8_;
#line 153 "../lib/ShadowEffect.vala"
	g_return_if_fail (self != NULL);
#line 154 "../lib/ShadowEffect.vala"
	_tmp0_ = self->priv->_scale_factor;
#line 154 "../lib/ShadowEffect.vala"
	size = self->priv->shadow_size * _tmp0_;
#line 155 "../lib/ShadowEffect.vala"
	memset (&bounding_box, 0, sizeof (ClutterActorBox));
#line 157 "../lib/ShadowEffect.vala"
	clutter_actor_box_set_origin (&bounding_box, -size, -size);
#line 158 "../lib/ShadowEffect.vala"
	_tmp1_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 158 "../lib/ShadowEffect.vala"
	_tmp2_ = _tmp1_;
#line 158 "../lib/ShadowEffect.vala"
	_tmp3_ = clutter_actor_get_width (_tmp2_);
#line 158 "../lib/ShadowEffect.vala"
	_tmp4_ = _tmp3_;
#line 158 "../lib/ShadowEffect.vala"
	_tmp5_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
#line 158 "../lib/ShadowEffect.vala"
	_tmp6_ = _tmp5_;
#line 158 "../lib/ShadowEffect.vala"
	_tmp7_ = clutter_actor_get_height (_tmp6_);
#line 158 "../lib/ShadowEffect.vala"
	_tmp8_ = _tmp7_;
#line 158 "../lib/ShadowEffect.vala"
	clutter_actor_box_set_size (&bounding_box, _tmp4_ + (size * 2), _tmp8_ + (size * 2));
#line 160 "../lib/ShadowEffect.vala"
	*result = bounding_box;
#line 160 "../lib/ShadowEffect.vala"
	return;
#line 711 "ShadowEffect.c"
}

static gboolean
gala_shadow_effect_real_modify_paint_volume (ClutterEffect* base,
                                             ClutterPaintVolume* volume)
{
	GalaShadowEffect * self;
	ClutterActorBox bounding_box = {0};
	ClutterActorBox _tmp0_ = {0};
	gfloat origin_x = 0.0F;
	gfloat origin_y = 0.0F;
	gfloat _tmp1_ = 0.0F;
	gfloat _tmp2_ = 0.0F;
	graphene_point3d_t origin = {0};
	graphene_point3d_t _tmp3_ = {0};
	graphene_point3d_t _tmp4_;
	gboolean result;
#line 163 "../lib/ShadowEffect.vala"
	self = (GalaShadowEffect*) base;
#line 163 "../lib/ShadowEffect.vala"
	g_return_val_if_fail (volume != NULL, FALSE);
#line 164 "../lib/ShadowEffect.vala"
	gala_shadow_effect_get_bounding_box (self, &_tmp0_);
#line 164 "../lib/ShadowEffect.vala"
	bounding_box = _tmp0_;
#line 166 "../lib/ShadowEffect.vala"
	clutter_paint_volume_set_width (volume, clutter_actor_box_get_width (&bounding_box));
#line 167 "../lib/ShadowEffect.vala"
	clutter_paint_volume_set_height (volume, clutter_actor_box_get_height (&bounding_box));
#line 170 "../lib/ShadowEffect.vala"
	clutter_actor_box_get_origin (&bounding_box, &_tmp1_, &_tmp2_);
#line 170 "../lib/ShadowEffect.vala"
	origin_x = _tmp1_;
#line 170 "../lib/ShadowEffect.vala"
	origin_y = _tmp2_;
#line 171 "../lib/ShadowEffect.vala"
	clutter_paint_volume_get_origin (volume, &_tmp3_);
#line 171 "../lib/ShadowEffect.vala"
	origin = _tmp3_;
#line 172 "../lib/ShadowEffect.vala"
	origin.x = origin.x + origin_x;
#line 173 "../lib/ShadowEffect.vala"
	origin.y = origin.y + origin_y;
#line 174 "../lib/ShadowEffect.vala"
	_tmp4_ = origin;
#line 174 "../lib/ShadowEffect.vala"
	clutter_paint_volume_set_origin (volume, &_tmp4_);
#line 176 "../lib/ShadowEffect.vala"
	result = TRUE;
#line 176 "../lib/ShadowEffect.vala"
	return result;
#line 763 "ShadowEffect.c"
}

static void
gala_shadow_effect_increment_shadow_users (const gchar* key)
{
	GalaShadowEffectShadow* shadow = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GalaShadowEffectShadow* _tmp2_;
	GalaShadowEffectShadow* _tmp3_;
	gint _tmp4_;
	guint timeout_id = 0U;
	GeeHashMap* _tmp5_;
	gpointer _tmp6_ = NULL;
	gboolean _tmp7_;
#line 179 "../lib/ShadowEffect.vala"
	g_return_if_fail (key != NULL);
#line 180 "../lib/ShadowEffect.vala"
	_tmp0_ = gala_shadow_effect_shadow_cache;
#line 180 "../lib/ShadowEffect.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, key);
#line 180 "../lib/ShadowEffect.vala"
	shadow = (GalaShadowEffectShadow*) _tmp1_;
#line 182 "../lib/ShadowEffect.vala"
	_tmp2_ = shadow;
#line 182 "../lib/ShadowEffect.vala"
	if (_tmp2_ == NULL) {
#line 183 "../lib/ShadowEffect.vala"
		_gala_shadow_effect_shadow_unref0 (shadow);
#line 183 "../lib/ShadowEffect.vala"
		return;
#line 795 "ShadowEffect.c"
	}
#line 186 "../lib/ShadowEffect.vala"
	_tmp3_ = shadow;
#line 186 "../lib/ShadowEffect.vala"
	_tmp4_ = _tmp3_->users;
#line 186 "../lib/ShadowEffect.vala"
	_tmp3_->users = _tmp4_ + 1;
#line 189 "../lib/ShadowEffect.vala"
	_tmp5_ = gala_shadow_effect_shadows_marked_for_dropping;
#line 189 "../lib/ShadowEffect.vala"
	_tmp7_ = gee_abstract_map_unset ((GeeAbstractMap*) _tmp5_, key, &_tmp6_);
#line 189 "../lib/ShadowEffect.vala"
	timeout_id = (guint) ((guintptr) _tmp6_);
#line 189 "../lib/ShadowEffect.vala"
	if (_tmp7_) {
#line 190 "../lib/ShadowEffect.vala"
		g_source_remove (timeout_id);
#line 813 "ShadowEffect.c"
	}
#line 179 "../lib/ShadowEffect.vala"
	_gala_shadow_effect_shadow_unref0 (shadow);
#line 817 "ShadowEffect.c"
}

static void
gala_shadow_effect_decrement_shadow_users (const gchar* key)
{
	GalaShadowEffectShadow* shadow = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GalaShadowEffectShadow* _tmp2_;
	GalaShadowEffectShadow* _tmp3_;
	gint _tmp4_;
#line 194 "../lib/ShadowEffect.vala"
	g_return_if_fail (key != NULL);
#line 195 "../lib/ShadowEffect.vala"
	_tmp0_ = gala_shadow_effect_shadow_cache;
#line 195 "../lib/ShadowEffect.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, key);
#line 195 "../lib/ShadowEffect.vala"
	shadow = (GalaShadowEffectShadow*) _tmp1_;
#line 197 "../lib/ShadowEffect.vala"
	_tmp2_ = shadow;
#line 197 "../lib/ShadowEffect.vala"
	if (_tmp2_ == NULL) {
#line 198 "../lib/ShadowEffect.vala"
		_gala_shadow_effect_shadow_unref0 (shadow);
#line 198 "../lib/ShadowEffect.vala"
		return;
#line 845 "ShadowEffect.c"
	}
#line 201 "../lib/ShadowEffect.vala"
	_tmp3_ = shadow;
#line 201 "../lib/ShadowEffect.vala"
	_tmp3_->users = _tmp3_->users - 1;
#line 201 "../lib/ShadowEffect.vala"
	_tmp4_ = _tmp3_->users;
#line 201 "../lib/ShadowEffect.vala"
	if (_tmp4_ == 0) {
#line 202 "../lib/ShadowEffect.vala"
		gala_shadow_effect_queue_shadow_drop (key);
#line 857 "ShadowEffect.c"
	}
#line 194 "../lib/ShadowEffect.vala"
	_gala_shadow_effect_shadow_unref0 (shadow);
#line 861 "ShadowEffect.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 206 "../lib/ShadowEffect.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 206 "../lib/ShadowEffect.vala"
	return _data4_;
#line 871 "ShadowEffect.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 206 "../lib/ShadowEffect.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 206 "../lib/ShadowEffect.vala"
		_g_free0 (_data4_->key);
#line 206 "../lib/ShadowEffect.vala"
		g_slice_free (Block4Data, _data4_);
#line 885 "ShadowEffect.c"
	}
}

static gboolean
__lambda21_ (Block4Data* _data4_)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	gboolean result;
#line 208 "../lib/ShadowEffect.vala"
	_tmp0_ = gala_shadow_effect_shadow_cache;
#line 208 "../lib/ShadowEffect.vala"
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp0_, _data4_->key, NULL);
#line 209 "../lib/ShadowEffect.vala"
	_tmp1_ = gala_shadow_effect_shadows_marked_for_dropping;
#line 209 "../lib/ShadowEffect.vala"
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp1_, _data4_->key, NULL);
#line 210 "../lib/ShadowEffect.vala"
	result = G_SOURCE_REMOVE;
#line 210 "../lib/ShadowEffect.vala"
	return result;
#line 907 "ShadowEffect.c"
}

static gboolean
___lambda21__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda21_ (self);
#line 207 "../lib/ShadowEffect.vala"
	return result;
#line 917 "ShadowEffect.c"
}

static void
gala_shadow_effect_queue_shadow_drop (const gchar* key)
{
	Block4Data* _data4_;
	gchar* _tmp0_;
	GeeHashMap* _tmp1_;
#line 206 "../lib/ShadowEffect.vala"
	g_return_if_fail (key != NULL);
#line 206 "../lib/ShadowEffect.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 206 "../lib/ShadowEffect.vala"
	_data4_->_ref_count_ = 1;
#line 206 "../lib/ShadowEffect.vala"
	_tmp0_ = g_strdup (key);
#line 206 "../lib/ShadowEffect.vala"
	_g_free0 (_data4_->key);
#line 206 "../lib/ShadowEffect.vala"
	_data4_->key = _tmp0_;
#line 207 "../lib/ShadowEffect.vala"
	_tmp1_ = gala_shadow_effect_shadows_marked_for_dropping;
#line 207 "../lib/ShadowEffect.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp1_, _data4_->key, (gpointer) ((guintptr) g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 5, ___lambda21__gsource_func, block4_data_ref (_data4_), block4_data_unref)));
#line 206 "../lib/ShadowEffect.vala"
	block4_data_unref (_data4_);
#line 206 "../lib/ShadowEffect.vala"
	_data4_ = NULL;
#line 946 "ShadowEffect.c"
}

const gchar*
gala_shadow_effect_get_css_class (GalaShadowEffect* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 33 "../lib/ShadowEffect.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../lib/ShadowEffect.vala"
	_tmp0_ = self->priv->_css_class;
#line 34 "../lib/ShadowEffect.vala"
	result = _tmp0_;
#line 34 "../lib/ShadowEffect.vala"
	return result;
#line 962 "ShadowEffect.c"
}

void
gala_shadow_effect_set_css_class (GalaShadowEffect* self,
                                  const gchar* value)
{
	gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 39 "../lib/ShadowEffect.vala"
	static GQuark _tmp2_label0 = 0;
#line 39 "../lib/ShadowEffect.vala"
	static GQuark _tmp2_label1 = 0;
#line 37 "../lib/ShadowEffect.vala"
	g_return_if_fail (self != NULL);
#line 38 "../lib/ShadowEffect.vala"
	_tmp0_ = g_strdup (value);
#line 38 "../lib/ShadowEffect.vala"
	_g_free0 (self->priv->_css_class);
#line 38 "../lib/ShadowEffect.vala"
	self->priv->_css_class = _tmp0_;
#line 39 "../lib/ShadowEffect.vala"
	_tmp1_ = value;
#line 39 "../lib/ShadowEffect.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 39 "../lib/ShadowEffect.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("workspace-switcher")))) {
#line 39 "../lib/ShadowEffect.vala"
		switch (0) {
#line 992 "ShadowEffect.c"
			default:
			{
#line 41 "../lib/ShadowEffect.vala"
				self->priv->shadow_size = 6;
#line 42 "../lib/ShadowEffect.vala"
				break;
#line 999 "ShadowEffect.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("window")))) {
#line 39 "../lib/ShadowEffect.vala"
		switch (0) {
#line 1005 "ShadowEffect.c"
			default:
			{
#line 44 "../lib/ShadowEffect.vala"
				self->priv->shadow_size = 55;
#line 45 "../lib/ShadowEffect.vala"
				break;
#line 1012 "ShadowEffect.c"
			}
		}
	} else {
#line 39 "../lib/ShadowEffect.vala"
		switch (0) {
#line 1018 "ShadowEffect.c"
			default:
			{
#line 47 "../lib/ShadowEffect.vala"
				self->priv->shadow_size = 18;
#line 48 "../lib/ShadowEffect.vala"
				break;
#line 1025 "ShadowEffect.c"
			}
		}
	}
#line 37 "../lib/ShadowEffect.vala"
	g_object_notify_by_pspec ((GObject *) self, gala_shadow_effect_properties[GALA_SHADOW_EFFECT_CSS_CLASS_PROPERTY]);
#line 1031 "ShadowEffect.c"
}

gfloat
gala_shadow_effect_get_scale_factor (GalaShadowEffect* self)
{
	gfloat result;
#line 53 "../lib/ShadowEffect.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 53 "../lib/ShadowEffect.vala"
	result = self->priv->_scale_factor;
#line 53 "../lib/ShadowEffect.vala"
	return result;
#line 1044 "ShadowEffect.c"
}

void
gala_shadow_effect_set_scale_factor (GalaShadowEffect* self,
                                     gfloat value)
{
	gfloat old_value;
#line 53 "../lib/ShadowEffect.vala"
	g_return_if_fail (self != NULL);
#line 53 "../lib/ShadowEffect.vala"
	old_value = gala_shadow_effect_get_scale_factor (self);
#line 53 "../lib/ShadowEffect.vala"
	if (old_value != value) {
#line 53 "../lib/ShadowEffect.vala"
		self->priv->_scale_factor = value;
#line 53 "../lib/ShadowEffect.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_shadow_effect_properties[GALA_SHADOW_EFFECT_SCALE_FACTOR_PROPERTY]);
#line 1062 "ShadowEffect.c"
	}
}

guint8
gala_shadow_effect_get_shadow_opacity (GalaShadowEffect* self)
{
	guint8 result;
#line 54 "../lib/ShadowEffect.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 54 "../lib/ShadowEffect.vala"
	result = self->priv->_shadow_opacity;
#line 54 "../lib/ShadowEffect.vala"
	return result;
#line 1076 "ShadowEffect.c"
}

void
gala_shadow_effect_set_shadow_opacity (GalaShadowEffect* self,
                                       guint8 value)
{
	guint8 old_value;
#line 54 "../lib/ShadowEffect.vala"
	g_return_if_fail (self != NULL);
#line 54 "../lib/ShadowEffect.vala"
	old_value = gala_shadow_effect_get_shadow_opacity (self);
#line 54 "../lib/ShadowEffect.vala"
	if (old_value != value) {
#line 54 "../lib/ShadowEffect.vala"
		self->priv->_shadow_opacity = value;
#line 54 "../lib/ShadowEffect.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_shadow_effect_properties[GALA_SHADOW_EFFECT_SHADOW_OPACITY_PROPERTY]);
#line 1094 "ShadowEffect.c"
	}
}

gint
gala_shadow_effect_get_border_radius (GalaShadowEffect* self)
{
	gint result;
#line 55 "../lib/ShadowEffect.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 55 "../lib/ShadowEffect.vala"
	result = self->priv->_border_radius;
#line 55 "../lib/ShadowEffect.vala"
	return result;
#line 1108 "ShadowEffect.c"
}

void
gala_shadow_effect_set_border_radius (GalaShadowEffect* self,
                                      gint value)
{
	gint old_value;
#line 55 "../lib/ShadowEffect.vala"
	g_return_if_fail (self != NULL);
#line 55 "../lib/ShadowEffect.vala"
	old_value = gala_shadow_effect_get_border_radius (self);
#line 55 "../lib/ShadowEffect.vala"
	if (old_value != value) {
#line 55 "../lib/ShadowEffect.vala"
		self->priv->_border_radius = value;
#line 55 "../lib/ShadowEffect.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_shadow_effect_properties[GALA_SHADOW_EFFECT_BORDER_RADIUS_PROPERTY]);
#line 1126 "ShadowEffect.c"
	}
}

static GalaShadowEffectShadow*
gala_shadow_effect_shadow_construct (GType object_type,
                                     CoglTexture* _texture)
{
	GalaShadowEffectShadow* self = NULL;
	CoglTexture* _tmp0_;
#line 12 "../lib/ShadowEffect.vala"
	g_return_val_if_fail (_texture != NULL, NULL);
#line 12 "../lib/ShadowEffect.vala"
	self = (GalaShadowEffectShadow*) g_type_create_instance (object_type);
#line 13 "../lib/ShadowEffect.vala"
	_tmp0_ = _g_object_ref0 (_texture);
#line 13 "../lib/ShadowEffect.vala"
	_g_object_unref0 (self->texture);
#line 13 "../lib/ShadowEffect.vala"
	self->texture = _tmp0_;
#line 14 "../lib/ShadowEffect.vala"
	self->users = 1;
#line 12 "../lib/ShadowEffect.vala"
	return self;
#line 1150 "ShadowEffect.c"
}

static GalaShadowEffectShadow*
gala_shadow_effect_shadow_new (CoglTexture* _texture)
{
#line 12 "../lib/ShadowEffect.vala"
	return gala_shadow_effect_shadow_construct (GALA_SHADOW_EFFECT_TYPE_SHADOW, _texture);
#line 1158 "ShadowEffect.c"
}

static void
gala_shadow_effect_value_shadow_init (GValue* value)
{
#line 8 "../lib/ShadowEffect.vala"
	value->data[0].v_pointer = NULL;
#line 1166 "ShadowEffect.c"
}

static void
gala_shadow_effect_value_shadow_free_value (GValue* value)
{
#line 8 "../lib/ShadowEffect.vala"
	if (value->data[0].v_pointer) {
#line 8 "../lib/ShadowEffect.vala"
		gala_shadow_effect_shadow_unref (value->data[0].v_pointer);
#line 1176 "ShadowEffect.c"
	}
}

static void
gala_shadow_effect_value_shadow_copy_value (const GValue* src_value,
                                            GValue* dest_value)
{
#line 8 "../lib/ShadowEffect.vala"
	if (src_value->data[0].v_pointer) {
#line 8 "../lib/ShadowEffect.vala"
		dest_value->data[0].v_pointer = gala_shadow_effect_shadow_ref (src_value->data[0].v_pointer);
#line 1188 "ShadowEffect.c"
	} else {
#line 8 "../lib/ShadowEffect.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1192 "ShadowEffect.c"
	}
}

static gpointer
gala_shadow_effect_value_shadow_peek_pointer (const GValue* value)
{
#line 8 "../lib/ShadowEffect.vala"
	return value->data[0].v_pointer;
#line 1201 "ShadowEffect.c"
}

static gchar*
gala_shadow_effect_value_shadow_collect_value (GValue* value,
                                               guint n_collect_values,
                                               GTypeCValue* collect_values,
                                               guint collect_flags)
{
#line 8 "../lib/ShadowEffect.vala"
	if (collect_values[0].v_pointer) {
#line 1212 "ShadowEffect.c"
		GalaShadowEffectShadow * object;
		object = collect_values[0].v_pointer;
#line 8 "../lib/ShadowEffect.vala"
		if (object->parent_instance.g_class == NULL) {
#line 8 "../lib/ShadowEffect.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1219 "ShadowEffect.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 8 "../lib/ShadowEffect.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1223 "ShadowEffect.c"
		}
#line 8 "../lib/ShadowEffect.vala"
		value->data[0].v_pointer = gala_shadow_effect_shadow_ref (object);
#line 1227 "ShadowEffect.c"
	} else {
#line 8 "../lib/ShadowEffect.vala"
		value->data[0].v_pointer = NULL;
#line 1231 "ShadowEffect.c"
	}
#line 8 "../lib/ShadowEffect.vala"
	return NULL;
#line 1235 "ShadowEffect.c"
}

static gchar*
gala_shadow_effect_value_shadow_lcopy_value (const GValue* value,
                                             guint n_collect_values,
                                             GTypeCValue* collect_values,
                                             guint collect_flags)
{
	GalaShadowEffectShadow ** object_p;
	object_p = collect_values[0].v_pointer;
#line 8 "../lib/ShadowEffect.vala"
	if (!object_p) {
#line 8 "../lib/ShadowEffect.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1250 "ShadowEffect.c"
	}
#line 8 "../lib/ShadowEffect.vala"
	if (!value->data[0].v_pointer) {
#line 8 "../lib/ShadowEffect.vala"
		*object_p = NULL;
#line 1256 "ShadowEffect.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 8 "../lib/ShadowEffect.vala"
		*object_p = value->data[0].v_pointer;
#line 1260 "ShadowEffect.c"
	} else {
#line 8 "../lib/ShadowEffect.vala"
		*object_p = gala_shadow_effect_shadow_ref (value->data[0].v_pointer);
#line 1264 "ShadowEffect.c"
	}
#line 8 "../lib/ShadowEffect.vala"
	return NULL;
#line 1268 "ShadowEffect.c"
}

static GParamSpec*
gala_shadow_effect_param_spec_shadow (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags)
{
	GalaShadowEffectParamSpecShadow* spec;
#line 8 "../lib/ShadowEffect.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GALA_SHADOW_EFFECT_TYPE_SHADOW), NULL);
#line 8 "../lib/ShadowEffect.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 8 "../lib/ShadowEffect.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 8 "../lib/ShadowEffect.vala"
	return G_PARAM_SPEC (spec);
#line 1287 "ShadowEffect.c"
}

static gpointer
gala_shadow_effect_value_get_shadow (const GValue* value)
{
#line 8 "../lib/ShadowEffect.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GALA_SHADOW_EFFECT_TYPE_SHADOW), NULL);
#line 8 "../lib/ShadowEffect.vala"
	return value->data[0].v_pointer;
#line 1297 "ShadowEffect.c"
}

static void
gala_shadow_effect_value_set_shadow (GValue* value,
                                     gpointer v_object)
{
	GalaShadowEffectShadow * old;
#line 8 "../lib/ShadowEffect.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GALA_SHADOW_EFFECT_TYPE_SHADOW));
#line 8 "../lib/ShadowEffect.vala"
	old = value->data[0].v_pointer;
#line 8 "../lib/ShadowEffect.vala"
	if (v_object) {
#line 8 "../lib/ShadowEffect.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GALA_SHADOW_EFFECT_TYPE_SHADOW));
#line 8 "../lib/ShadowEffect.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 8 "../lib/ShadowEffect.vala"
		value->data[0].v_pointer = v_object;
#line 8 "../lib/ShadowEffect.vala"
		gala_shadow_effect_shadow_ref (value->data[0].v_pointer);
#line 1319 "ShadowEffect.c"
	} else {
#line 8 "../lib/ShadowEffect.vala"
		value->data[0].v_pointer = NULL;
#line 1323 "ShadowEffect.c"
	}
#line 8 "../lib/ShadowEffect.vala"
	if (old) {
#line 8 "../lib/ShadowEffect.vala"
		gala_shadow_effect_shadow_unref (old);
#line 1329 "ShadowEffect.c"
	}
}

static void
gala_shadow_effect_value_take_shadow (GValue* value,
                                      gpointer v_object)
{
	GalaShadowEffectShadow * old;
#line 8 "../lib/ShadowEffect.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GALA_SHADOW_EFFECT_TYPE_SHADOW));
#line 8 "../lib/ShadowEffect.vala"
	old = value->data[0].v_pointer;
#line 8 "../lib/ShadowEffect.vala"
	if (v_object) {
#line 8 "../lib/ShadowEffect.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GALA_SHADOW_EFFECT_TYPE_SHADOW));
#line 8 "../lib/ShadowEffect.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 8 "../lib/ShadowEffect.vala"
		value->data[0].v_pointer = v_object;
#line 1350 "ShadowEffect.c"
	} else {
#line 8 "../lib/ShadowEffect.vala"
		value->data[0].v_pointer = NULL;
#line 1354 "ShadowEffect.c"
	}
#line 8 "../lib/ShadowEffect.vala"
	if (old) {
#line 8 "../lib/ShadowEffect.vala"
		gala_shadow_effect_shadow_unref (old);
#line 1360 "ShadowEffect.c"
	}
}

static void
gala_shadow_effect_shadow_class_init (GalaShadowEffectShadowClass * klass,
                                      gpointer klass_data)
{
#line 8 "../lib/ShadowEffect.vala"
	gala_shadow_effect_shadow_parent_class = g_type_class_peek_parent (klass);
#line 8 "../lib/ShadowEffect.vala"
	((GalaShadowEffectShadowClass *) klass)->finalize = gala_shadow_effect_shadow_finalize;
#line 1372 "ShadowEffect.c"
}

static void
gala_shadow_effect_shadow_instance_init (GalaShadowEffectShadow * self,
                                         gpointer klass)
{
#line 8 "../lib/ShadowEffect.vala"
	self->ref_count = 1;
#line 1381 "ShadowEffect.c"
}

static void
gala_shadow_effect_shadow_finalize (GalaShadowEffectShadow * obj)
{
	GalaShadowEffectShadow * self;
#line 8 "../lib/ShadowEffect.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_SHADOW_EFFECT_TYPE_SHADOW, GalaShadowEffectShadow);
#line 8 "../lib/ShadowEffect.vala"
	g_signal_handlers_destroy (self);
#line 10 "../lib/ShadowEffect.vala"
	_g_object_unref0 (self->texture);
#line 1394 "ShadowEffect.c"
}

 G_GNUC_NO_INLINE static GType
gala_shadow_effect_shadow_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { gala_shadow_effect_value_shadow_init, gala_shadow_effect_value_shadow_free_value, gala_shadow_effect_value_shadow_copy_value, gala_shadow_effect_value_shadow_peek_pointer, "p", gala_shadow_effect_value_shadow_collect_value, "p", gala_shadow_effect_value_shadow_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GalaShadowEffectShadowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_shadow_effect_shadow_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaShadowEffectShadow), 0, (GInstanceInitFunc) gala_shadow_effect_shadow_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType gala_shadow_effect_shadow_type_id;
	gala_shadow_effect_shadow_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GalaShadowEffectShadow", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return gala_shadow_effect_shadow_type_id;
}

static GType
gala_shadow_effect_shadow_get_type (void)
{
	static gsize gala_shadow_effect_shadow_type_id__once = 0;
	if (g_once_init_enter (&gala_shadow_effect_shadow_type_id__once)) {
		GType gala_shadow_effect_shadow_type_id;
		gala_shadow_effect_shadow_type_id = gala_shadow_effect_shadow_get_type_once ();
		g_once_init_leave (&gala_shadow_effect_shadow_type_id__once, gala_shadow_effect_shadow_type_id);
	}
	return gala_shadow_effect_shadow_type_id__once;
}

static gpointer
gala_shadow_effect_shadow_ref (gpointer instance)
{
	GalaShadowEffectShadow * self;
	self = instance;
#line 8 "../lib/ShadowEffect.vala"
	g_atomic_int_inc (&self->ref_count);
#line 8 "../lib/ShadowEffect.vala"
	return instance;
#line 1429 "ShadowEffect.c"
}

static void
gala_shadow_effect_shadow_unref (gpointer instance)
{
	GalaShadowEffectShadow * self;
	self = instance;
#line 8 "../lib/ShadowEffect.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 8 "../lib/ShadowEffect.vala"
		GALA_SHADOW_EFFECT_SHADOW_GET_CLASS (self)->finalize (self);
#line 8 "../lib/ShadowEffect.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1443 "ShadowEffect.c"
	}
}

static GObject *
gala_shadow_effect_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaShadowEffect * self;
	ClutterBackend* _tmp0_;
	CoglContext* _tmp1_;
	CoglPipeline* _tmp2_;
#line 65 "../lib/ShadowEffect.vala"
	parent_class = G_OBJECT_CLASS (gala_shadow_effect_parent_class);
#line 65 "../lib/ShadowEffect.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 65 "../lib/ShadowEffect.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_SHADOW_EFFECT, GalaShadowEffect);
#line 66 "../lib/ShadowEffect.vala"
	_tmp0_ = clutter_get_default_backend ();
#line 66 "../lib/ShadowEffect.vala"
	_tmp1_ = clutter_backend_get_cogl_context (_tmp0_);
#line 66 "../lib/ShadowEffect.vala"
	_tmp2_ = cogl_pipeline_new (_tmp1_);
#line 66 "../lib/ShadowEffect.vala"
	_g_object_unref0 (self->priv->pipeline);
#line 66 "../lib/ShadowEffect.vala"
	self->priv->pipeline = _tmp2_;
#line 65 "../lib/ShadowEffect.vala"
	return obj;
#line 1476 "ShadowEffect.c"
}

static void
gala_shadow_effect_class_init (GalaShadowEffectClass * klass,
                               gpointer klass_data)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
#line 7 "../lib/ShadowEffect.vala"
	gala_shadow_effect_parent_class = g_type_class_peek_parent (klass);
#line 7 "../lib/ShadowEffect.vala"
	g_type_class_adjust_private_offset (klass, &GalaShadowEffect_private_offset);
#line 7 "../lib/ShadowEffect.vala"
	((ClutterEffectClass *) klass)->paint = (void (*) (ClutterEffect*, ClutterPaintNode*, ClutterPaintContext*, ClutterEffectPaintFlags)) gala_shadow_effect_real_paint;
#line 7 "../lib/ShadowEffect.vala"
	((ClutterEffectClass *) klass)->modify_paint_volume = (gboolean (*) (ClutterEffect*, ClutterPaintVolume*)) gala_shadow_effect_real_modify_paint_volume;
#line 7 "../lib/ShadowEffect.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_shadow_effect_get_property;
#line 7 "../lib/ShadowEffect.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_shadow_effect_set_property;
#line 7 "../lib/ShadowEffect.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_shadow_effect_constructor;
#line 7 "../lib/ShadowEffect.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_shadow_effect_finalize;
#line 7 "../lib/ShadowEffect.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_SHADOW_EFFECT_CSS_CLASS_PROPERTY, gala_shadow_effect_properties[GALA_SHADOW_EFFECT_CSS_CLASS_PROPERTY] = g_param_spec_string ("css-class", "css-class", "css-class", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 7 "../lib/ShadowEffect.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_SHADOW_EFFECT_SCALE_FACTOR_PROPERTY, gala_shadow_effect_properties[GALA_SHADOW_EFFECT_SCALE_FACTOR_PROPERTY] = g_param_spec_float ("scale-factor", "scale-factor", "scale-factor", -G_MAXFLOAT, G_MAXFLOAT, (gfloat) 1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 7 "../lib/ShadowEffect.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_SHADOW_EFFECT_SHADOW_OPACITY_PROPERTY, gala_shadow_effect_properties[GALA_SHADOW_EFFECT_SHADOW_OPACITY_PROPERTY] = g_param_spec_uchar ("shadow-opacity", "shadow-opacity", "shadow-opacity", 0, G_MAXUINT8, (guint8) 255, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 7 "../lib/ShadowEffect.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_SHADOW_EFFECT_BORDER_RADIUS_PROPERTY, gala_shadow_effect_properties[GALA_SHADOW_EFFECT_BORDER_RADIUS_PROPERTY] = g_param_spec_int ("border-radius", "border-radius", "border-radius", G_MININT, G_MAXINT, 9, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../lib/ShadowEffect.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GALA_SHADOW_EFFECT_TYPE_SHADOW, (GBoxedCopyFunc) gala_shadow_effect_shadow_ref, (GDestroyNotify) gala_shadow_effect_shadow_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 27 "../lib/ShadowEffect.vala"
	_g_object_unref0 (gala_shadow_effect_shadow_cache);
#line 27 "../lib/ShadowEffect.vala"
	gala_shadow_effect_shadow_cache = _tmp0_;
#line 28 "../lib/ShadowEffect.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 28 "../lib/ShadowEffect.vala"
	_g_object_unref0 (gala_shadow_effect_shadows_marked_for_dropping);
#line 28 "../lib/ShadowEffect.vala"
	gala_shadow_effect_shadows_marked_for_dropping = _tmp1_;
#line 1521 "ShadowEffect.c"
}

static void
gala_shadow_effect_instance_init (GalaShadowEffect * self,
                                  gpointer klass)
{
#line 7 "../lib/ShadowEffect.vala"
	self->priv = gala_shadow_effect_get_instance_private (self);
#line 53 "../lib/ShadowEffect.vala"
	self->priv->_scale_factor = (gfloat) 1;
#line 54 "../lib/ShadowEffect.vala"
	self->priv->_shadow_opacity = (guint8) 255;
#line 55 "../lib/ShadowEffect.vala"
	self->priv->_border_radius = 9;
#line 59 "../lib/ShadowEffect.vala"
	self->priv->current_key = NULL;
#line 1538 "ShadowEffect.c"
}

static void
gala_shadow_effect_finalize (GObject * obj)
{
	GalaShadowEffect * self;
	const gchar* _tmp0_;
#line 7 "../lib/ShadowEffect.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_SHADOW_EFFECT, GalaShadowEffect);
#line 70 "../lib/ShadowEffect.vala"
	_tmp0_ = self->priv->current_key;
#line 70 "../lib/ShadowEffect.vala"
	if (_tmp0_ != NULL) {
#line 1552 "ShadowEffect.c"
		const gchar* _tmp1_;
#line 71 "../lib/ShadowEffect.vala"
		_tmp1_ = self->priv->current_key;
#line 71 "../lib/ShadowEffect.vala"
		gala_shadow_effect_decrement_shadow_users (_tmp1_);
#line 1558 "ShadowEffect.c"
	}
#line 31 "../lib/ShadowEffect.vala"
	_g_free0 (self->priv->_css_class);
#line 58 "../lib/ShadowEffect.vala"
	_g_object_unref0 (self->priv->pipeline);
#line 59 "../lib/ShadowEffect.vala"
	_g_free0 (self->priv->current_key);
#line 7 "../lib/ShadowEffect.vala"
	G_OBJECT_CLASS (gala_shadow_effect_parent_class)->finalize (obj);
#line 1568 "ShadowEffect.c"
}

 G_GNUC_NO_INLINE static GType
gala_shadow_effect_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaShadowEffectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_shadow_effect_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaShadowEffect), 0, (GInstanceInitFunc) gala_shadow_effect_instance_init, NULL };
	GType gala_shadow_effect_type_id;
	gala_shadow_effect_type_id = g_type_register_static (clutter_effect_get_type (), "GalaShadowEffect", &g_define_type_info, 0);
	GalaShadowEffect_private_offset = g_type_add_instance_private (gala_shadow_effect_type_id, sizeof (GalaShadowEffectPrivate));
	return gala_shadow_effect_type_id;
}

GType
gala_shadow_effect_get_type (void)
{
	static gsize gala_shadow_effect_type_id__once = 0;
	if (g_once_init_enter (&gala_shadow_effect_type_id__once)) {
		GType gala_shadow_effect_type_id;
		gala_shadow_effect_type_id = gala_shadow_effect_get_type_once ();
		g_once_init_leave (&gala_shadow_effect_type_id__once, gala_shadow_effect_type_id);
	}
	return gala_shadow_effect_type_id__once;
}

static void
_vala_gala_shadow_effect_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	GalaShadowEffect * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_SHADOW_EFFECT, GalaShadowEffect);
#line 7 "../lib/ShadowEffect.vala"
	switch (property_id) {
#line 7 "../lib/ShadowEffect.vala"
		case GALA_SHADOW_EFFECT_CSS_CLASS_PROPERTY:
#line 7 "../lib/ShadowEffect.vala"
		g_value_set_string (value, gala_shadow_effect_get_css_class (self));
#line 7 "../lib/ShadowEffect.vala"
		break;
#line 7 "../lib/ShadowEffect.vala"
		case GALA_SHADOW_EFFECT_SCALE_FACTOR_PROPERTY:
#line 7 "../lib/ShadowEffect.vala"
		g_value_set_float (value, gala_shadow_effect_get_scale_factor (self));
#line 7 "../lib/ShadowEffect.vala"
		break;
#line 7 "../lib/ShadowEffect.vala"
		case GALA_SHADOW_EFFECT_SHADOW_OPACITY_PROPERTY:
#line 7 "../lib/ShadowEffect.vala"
		g_value_set_uchar (value, gala_shadow_effect_get_shadow_opacity (self));
#line 7 "../lib/ShadowEffect.vala"
		break;
#line 7 "../lib/ShadowEffect.vala"
		case GALA_SHADOW_EFFECT_BORDER_RADIUS_PROPERTY:
#line 7 "../lib/ShadowEffect.vala"
		g_value_set_int (value, gala_shadow_effect_get_border_radius (self));
#line 7 "../lib/ShadowEffect.vala"
		break;
#line 1627 "ShadowEffect.c"
		default:
#line 7 "../lib/ShadowEffect.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../lib/ShadowEffect.vala"
		break;
#line 1633 "ShadowEffect.c"
	}
}

static void
_vala_gala_shadow_effect_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	GalaShadowEffect * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_SHADOW_EFFECT, GalaShadowEffect);
#line 7 "../lib/ShadowEffect.vala"
	switch (property_id) {
#line 7 "../lib/ShadowEffect.vala"
		case GALA_SHADOW_EFFECT_CSS_CLASS_PROPERTY:
#line 7 "../lib/ShadowEffect.vala"
		gala_shadow_effect_set_css_class (self, g_value_get_string (value));
#line 7 "../lib/ShadowEffect.vala"
		break;
#line 7 "../lib/ShadowEffect.vala"
		case GALA_SHADOW_EFFECT_SCALE_FACTOR_PROPERTY:
#line 7 "../lib/ShadowEffect.vala"
		gala_shadow_effect_set_scale_factor (self, g_value_get_float (value));
#line 7 "../lib/ShadowEffect.vala"
		break;
#line 7 "../lib/ShadowEffect.vala"
		case GALA_SHADOW_EFFECT_SHADOW_OPACITY_PROPERTY:
#line 7 "../lib/ShadowEffect.vala"
		gala_shadow_effect_set_shadow_opacity (self, g_value_get_uchar (value));
#line 7 "../lib/ShadowEffect.vala"
		break;
#line 7 "../lib/ShadowEffect.vala"
		case GALA_SHADOW_EFFECT_BORDER_RADIUS_PROPERTY:
#line 7 "../lib/ShadowEffect.vala"
		gala_shadow_effect_set_border_radius (self, g_value_get_int (value));
#line 7 "../lib/ShadowEffect.vala"
		break;
#line 1671 "ShadowEffect.c"
		default:
#line 7 "../lib/ShadowEffect.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../lib/ShadowEffect.vala"
		break;
#line 1677 "ShadowEffect.c"
	}
}

